﻿package implement

import (
	"code.fnuoos.com/EggPlanet/egg_models.git/src/dao"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	zhios_order_relate_logx "code.fnuoos.com/EggPlanet/egg_models.git/utils/logx"
	"xorm.io/xorm"
)

func NewNewUserRedPackageWithUserRecordsDb(engine *xorm.Engine) dao.NewUserRedPackageWithUserRecordsDao {
	return &NewUserRedPackageWithUserRecordsDb{Db: engine}
}

type NewUserRedPackageWithUserRecordsDb struct {
	Db *xorm.Engine
}

func (n NewUserRedPackageWithUserRecordsDb) NewUserRedPackageWithUserRecordsFind(page, limit int, uid int64, startAt, endAt string) (*[]model.NewUserRedPackageWithUserRecords, int64, error) {
	var m []model.NewUserRedPackageWithUserRecords
	session := n.Db.NewSession()
	if uid != 0 {
		session.Where(" uid = ? ", uid)
	}
	if startAt != "" {
		session.Where(" create_at >= ? ", startAt)
	}
	if endAt != "" {
		session.Where(" create_at <= ? ", endAt)
	}
	total, err := session.Limit(limit, (page-1)*limit).Desc("create_at").FindAndCount(&m)
	if err != nil {
		return nil, 0, zhios_order_relate_logx.Error(err)
	}
	return &m, total, nil
}
